## js-of-ocaml 2.5

=== Makefile ===

all: no_examples examples
no_examples: build doc

build: check_lwt compiler library ocamlbuild runtime jsoo_tools toplevel_lib

include Makefile.conf
-include Makefile.local

.PHONY: all no_examples compiler library ocamlbuild runtime examples check_lwt doc build jsoo_tools toplevel_lib toplevel

compiler:
	$(MAKE) -C compiler all lib
library:
	$(MAKE) -C lib
runtime:
	$(MAKE) -C runtime
jsoo_tools: compiler
	$(MAKE) -C jsoo_tools
toplevel_lib: compiler
	$(MAKE) -C lib toplevel_lib
ocamlbuild:
	$(MAKE) -C ocamlbuild
examples: compiler library runtime
	$(MAKE) -C examples
doc: library ocamlbuild
	$(MAKE) -C doc

toplevel:
	$(MAKE) -C toplevel

tests: compiler library runtime
	$(MAKE) -C tests
phantomtests: compiler library runtime
	$(MAKE) -C tests phantom

LWTERROR="Js_of_ocaml requires Lwt version 2.3.0 at least.  Please upgrade."
check_lwt:
	@if ocamlfind query lwt -l | ocaml tools/check_version.ml 2.3.0; then \
	  echo $(LWTERROR); exit 1; \
	fi

include Makefile.filelist

VERSION := $(shell head -n 1 VERSION)

install: install-lib install-bin

install-lib:
	ocamlfind install -patch-version ${VERSION} $(LIBRARY) lib/META $(INTF) $(IMPL) $(OTHERS) $(DOC) $(COMP_INTF) $(COMP_IMPL)

install-bin:
	install -d -m 755 $(BINDIR)
	install $(BIN) $(BINDIR)
	install $(TOOLS) $(BINDIR)

uninstall: uninstall-lib uninstall-bin

uninstall-lib:
	ocamlfind remove $(LIBRARY)

uninstall-bin:
	rm -f $(BINDIR)/$(COMPILER)
	rm -f $(BINDIR)/$(MINIFIER)
	rm -f $(BINDIR)/$(MKTOP)
	rm -f $(BINDIR)/$(MKCMIS)

reinstall: uninstall install

depend:
	$(MAKE) -C compiler depend
	$(MAKE) -C lib depend

clean:
	$(MAKE) -C compiler clean
	$(MAKE) -C jsoo_tools clean
	$(MAKE) -C lib clean
	$(MAKE) -C ocamlbuild clean
	$(MAKE) -C runtime clean
	$(MAKE) -C toplevel clean
	$(MAKE) -C examples clean
ifeq ($(wildcard tests),tests)
	$(MAKE) -C tests clean
	$(MAKE) -C doc clean
endif

realclean: clean
	find . -name "*~" -print | xargs rm -f
	find . -name "*.tmpjs" -print | xargs rm -f
	find . -name "#*" -print | xargs rm -f

dist:
	rm -rf /tmp/js_of_ocaml-${VERSION} &&\
        cd /tmp &&\
	git clone https://github.com/ocsigen/js_of_ocaml.git js_of_ocaml-${VERSION} &&\
	(cd js_of_ocaml-${VERSION}; git checkout ${VERSION}) &&\
	tar zcvf js_of_ocaml-${VERSION}.tar.gz js_of_ocaml-${VERSION} --exclude benchmarks --exclude .git --exclude tests

=== benchmarks/Makefile ===
# graphs without precompiled programs:
GRAPHSNOPR = time.pdf time-optim.pdf time-ocamljs.pdf nativejs.pdf

# graphs with precompiled programs:
GRAPHSPR = size.pdf size-ocamljs.pdf size-optim.pdf compiletime.pdf

# For full benchs:
all: _perf graphsnopr graphspr _noperf

graphsnopr: _noprecomp $(GRAPHSNOPR)

graphspr: __precomp $(GRAPHSPR)

# For fast benchs:
test: _perf fastrun $(GRAPHS) _noperf

exes= $(wildcard programs/*)

exesnames = $(exes:programs/%=%)

missingsizesml = $(exesnames:%=results/sizes/ml/%)
missingsizesocamljs = $(exesnames:%=results/sizes/ocamljs/%)
missingsizes=$(missingsizesml) $(missingsizesocamljs)

missingcompiletimes = $(exesnames:%=results/compiletimes/`hostname`/byte/%) $(exesnames:%=results/compiletimes/`hostname`/opt/%)
possiblymissingbenchs = results/times/`hostname`/nitro/js_of_ocaml/kb results/times/`hostname`/tm/js_of_ocaml/hamming results/times/`hostname`/tm/js_of_ocaml/splay

OCAML=ocaml unix.cma
RUN=$(OCAML) ./run.ml
REPORT=$(OCAML) ./report.ml

.PHONY: $(GRAPHSNOPR:.pdf=.svg) $(GRAPHSPR:.pdf=.svg) size.gpl _noprecomp

# compile with precompiled programs for creating benchs
__precomp:
	mkdir -p build/byte
	ln -sf $(exes:%=../../%) build/byte
	if [ ! -d precomptmp ] ; then $(RUN) -compile ; else cd precomptmp ; find . -type f -exec mv {} ../{} \; ; fi
	rm -rf precomptmp
	touch __precomp

# for running the test we do not want precompiled programs
__run:
	make _noprecomp
	$(RUN) -all
	make __possiblymissingbenchs
	touch __run

fastrun:
	make _noprecomp
	echo "======================== WARNING: fast benchs!"
	$(RUN) -ffast -all
	make __possiblymissingbenchs
	touch __run

_noprecomp:
	if [ -f __precomp ] ; \
	then \
	  rm -f __precomp ;\
	  mkdir -p precomptmp/build/byte ;\
	  mkdir -p build ;\
	  mkdir -p results ;\
	  find build -type d -exec mkdir -p precomptmp/{} \; ;\
	  find results -type d -exec mkdir -p precomptmp/{} \; ;\
	  for i in $(exesnames) ; do if [ -f build/byte/$$i ] ; then mv -f build/byte/$$i precomptmp/build/byte/ ; fi ; done ;\
	  for i in $(exesnames) ; do for j in build/*/$$i.js ; do if [ -f $$j ] ; then mv $$j precomptmp/$$j ; fi ; done ; done ;\
	  for i in $(exesnames) ; do for j in results/sizes/js_of_ocaml/*/$$i ; do if [ -f $$j ] ; then mv $$j precomptmp/$$j ; fi ; done ; done ;\
	  for i in $(exesnames) ; do for j in results/sizes/*/$$i ; do if [ -f $$j ] ; then mv $$j precomptmp/$$j ; fi ;done ; done ;\
	fi

__missingcompiletimes:
	mkdir -p results/compiletimes/`hostname`/byte/
	for i in $(missingcompiletimes) ; do if [ ! -f $$i ] ; then echo 0 > $$i ; fi ; done
	touch __missingcompiletimes

__possiblymissingbenchs:
	for i in $(possiblymissingbenchs) ; do if [ ! -f $$i ] ; then echo 0 > $$i ; fi ; done
	touch __possiblymissingbenchs

__missingsizes: __precomp
	for i in $(missingsizes) ; do if [ ! -f $$i ] ; then echo 0 > $$i ; fi ; done
	if [ -f results/sizes/ml/unison ] ; then echo 828471 > results/sizes/ml/unison ; fi
	if [ -f results/sizes/ml/ocamlc ] ; then echo 800771 > results/sizes/ml/ocamlc ; fi
	if [ -f results/sizes/ml/ocsigen_server ] ; then echo 0 > results/sizes/ml/ocsigen_server ; fi
	if [ -f results/sizes/ml/js_of_ocaml ] ; then echo 171361 > results/sizes/ml/js_of_ocaml ; fi
	if [ -f results/sizes/ml/boulderdash ] ; then echo 12920 > results/sizes/ml/boulderdash ; fi
	if [ -f results/sizes/ml/canvas ] ; then echo 740 > results/sizes/ml/canvas ; fi
	if [ -f results/sizes/ml/cubes ] ; then echo 3773 > results/sizes/ml/cubes ; fi
	if [ -f results/sizes/ml/minesweeper ] ; then echo 7106 > results/sizes/ml/minesweeper ; fi
	if [ -f results/sizes/ml/planet ] ; then echo 16488 > results/sizes/ml/planet ; fi
	if [ -f results/sizes/ml/sudoku ] ; then echo 2837 > results/sizes/ml/sudoku ; fi
	touch __missingsizes
# file sizes (without comments and spaces)
# find ../examples/sudoku/ -name "*.ml" -exec cat {} \; | perl /home/balat/kroko/js_of_ocaml/benchmarks/lib/remove_comments.pl | sed 's/^ *//g' | wc -c

# To generate SVG, we first need to run the benchs,
# then to add data for precompiled programs
time.svg: __run
	$(REPORT) -config report-time.config \
	 -omit binary_trees -omit fannkuch_redux -omit loop \
	 -max 5.5 -svg 7 500 150 -edgecaption -ylabel "Execution time" \
	 > $@

size.svg: size.gpl
	gnuplot < $^ > $@

size.gpl: __run __missingsizes
	$(REPORT) -config report-size.config \
	 -omit binary_trees -omit fannkuch_redux -omit loop \
	 -omit fannkuch_redux_2 \
	 -omit boyer_no_exc -omit kb_no_exc \
	 -append boulderdash \
	 -append canvas \
	 -append cubes \
	 -append minesweeper \
	 -append planet \
	 -append sudoku \
	 -append js_of_ocaml \
	 -append ocsigen_server \
	 -append ocamlc \
	 -append unison \
	 -max 3 -ylabel Size -script \
	 -svg 7 650 150 \
	| perl -pe 'BEGIN{undef $$/;} s/e\nplot/e\nset key at 23.75,1.80\nplot/smg' \
	 > $@

time-optim.svg: __run
	$(REPORT) -config report-time-optim.config \
	 -omit binary_trees -omit fannkuch_redux -omit loop \
	 -omit fannkuch_redux_2 \
	 -max 4 -svg 7 400 150 -edgecaption -ylabel "Execution time" \
	 > $@

size-optim.svg: __run __missingsizes
	$(REPORT) -config report-size-optim.config \
	 -omit binary_trees -omit fannkuch_redux -omit loop  \
	 -omit fannkuch_redux_2 \
	 -omit boyer_no_exc -omit kb_no_exc \
	 -append boulderdash \
	 -append canvas \
	 -append cubes \
	 -append minesweeper \
	 -append planet \
	 -append sudoku \
	 -append js_of_ocaml \
	 -append ocsigen_server \
	 -append ocamlc \
	 -append unison \
	 -max 2.5 -svg 7 650 150 -edgecaption -ylabel Size \
	 > $@

time-ocamljs.svg: __run
	$(REPORT) -config report-time-ocamljs.config \
	 -omit binary_trees -omit fannkuch_redux -omit loop \
	 -omit fannkuch_redux_2 \
	 -max 5.5 -svg 7 500 150 -edgecaption -ylabel "Execution time" \
	 > $@

size-ocamljs.svg: __run __precomp
	$(REPORT) -config report-size-ocamljs.config -omit loop \
	 -omit binary_trees -omit fannkuch_redux \
	 -omit fannkuch_redux_2 \
	 -omit spectral_norm \
	 -omit boyer_no_exc -omit kb_no_exc \
	 -omit boulderdash \
	 -omit canvas \
	 -omit cubes \
	 -omit minesweeper \
	 -omit planet \
	 -omit sudoku \
	 -omit js_of_ocaml \
	 -omit ocsigen_server \
	 -omit ocamlc \
	 -omit unison \
	 -max 5.5 -svg 7 500 150 -edgecaption -ylabel Size \
	 > $@

compiletime.svg: __run __precomp __missingcompiletimes
	$(REPORT) -config report-compiletime.config \
	 -omit binary_trees -omit fannkuch_redux -omit loop \
	 -max 2 -svg 7 500 150 -edgecaption -ylabel "Compile time" \
	 > $@

nativejs.svg: __run
	$(REPORT) -config report-nativejs.config \
	 -omit binary_trees -omit fannkuch_redux -omit loop \
	 -max 2.8 -svg 7 200 150 -edgecaption -ylabel "Execution time" \
	 > $@


%.pdf: %.svg
	inkscape -D --export-pdf="$@" -w 210 -h 297 $<

_perf:
	for i in /sys/devices/system/cpu/cpu* ; do if [ -f $$i/cpufreq/scaling_governor ] ; then sudo bash -c "echo performance > $$i/cpufreq/scaling_governor" ; fi ;done

_noperf:
	for i in /sys/devices/system/cpu/cpu* ; do if [ -f $$i/cpufreq/scaling_governor ] ; then sudo bash -c "echo ondemand > $$i/cpufreq/scaling_governor" ; fi ; done


clean: _noperf
	rm -rf results build __precomp __run *.svg *.pdf *~ precomptmp __missingsizes __missingcompiletimes __possiblymissingbenchs

=== compiler/Makefile ===

include ../Makefile.conf

all: $(COMPILER) $(MINIFIER) man

lib: compiler.cma compiler.cmxa compiler.cmxs

PACKAGES=findlib,cmdliner

OBJS=compiler_version.cmx \
     util.cmx pretty_print.cmx option.cmx reserved.cmx varPrinter.cmx \
     dgraph.cmx code.cmx javascript.cmx vlq64.cmx source_map.cmx \
     js_output.cmx js_simpl.cmx parse_info.cmx js_token.cmx js_parser.cmx \
     js_lexer.cmx parse_js.cmx primitive.cmx annot_parser.cmx annot_lexer.cmx \
     instr.cmx subst.cmx pure_fun.cmx deadcode.cmx \
     flow.cmx specialize.cmx specialize_js.cmx eval.cmx inline.cmx \
     tailcall.cmx freevars.cmx phisimpl.cmx \
     js_traverse.cmx js_assign.cmx js_tailcall.cmx \
     linker.cmx parse_bytecode.cmx generate.cmx driver.cmx \
     pseudoFs.cmx

COMPOBJS=$(OBJS) commonArg.cmx compileArg.cmx compile.cmx

$(COMPILER): compile.$(BEST)
	mv -f $< $@

$(MINIFIER): minify.$(BEST)
	mv -f $< $@


man: man/$(MINIFIER).1 man/$(COMPILER).1
man/$(MINIFIER).1: $(MINIFIER)
	mkdir -p man
	./$(MINIFIER) --help=groff >$@
man/$(COMPILER).1: $(COMPILER)
	mkdir -p man
	./$(COMPILER) --help=groff >$@

.INTERMEDIATE: compile.byte compile.opt minify.byte minify.opt

compile.byte: $(COMPOBJS:cmx=cmo)
	ocamlfind ocamlc $(SAFESTRING) -package $(PACKAGES) -linkpkg -o $@ $^
compile.opt: $(COMPOBJS)
	ocamlfind ocamlopt $(SAFESTRING) -package $(PACKAGES) -linkpkg -g -o $@ $^

minify.byte: $(OBJS:cmx=cmo) commonArg.cmo minifyArg.cmo minify.cmo
	ocamlfind ocamlc $(SAFESTRING) -package $(PACKAGES) -linkpkg -o $@ $^
minify.opt: $(OBJS:cmx=cmx) commonArg.cmx minifyArg.cmx minify.cmx
	ocamlfind ocamlopt $(SAFESTRING) -package $(PACKAGES) -linkpkg -g -o $@ $^


compiler.cmo: $(OBJS:cmx=cmo)
	ocamlfind ocamlc -pack -o $@ $^

compiler.cma: compiler.cmo
	ocamlfind ocamlc -a -o $@ $^

compiler.cmx: $(OBJS)
	ocamlfind ocamlopt -pack -g -o $@ $^

compiler.cmxa: compiler.cmx
	ocamlfind ocamlopt -a -o $@ $^

compiler.cmxs: compiler.cmxa
	ocamlfind ocamlopt -shared -g -o $@ $^

VERSION := $(shell head -n 1 ../VERSION)

compiler_version.ml: compiler_version.ml.tmp
	if cmp -s $^ $@; then rm $^; else mv $^ $@; fi

.PHONY: compiler_version.ml.tmp
compiler_version.ml.tmp:
	echo "let s = \"${VERSION}\"" > $@
	echo "let git_version = \"${VERSION_GIT}\"" >> $@

%.cmx: %.ml
	ocamlfind ocamlopt $(SAFESTRING) -package $(PACKAGES) -for-pack Compiler -g -c $<

%.cmo: %.ml
	ocamlfind ocamlc $(SAFESTRING) -package $(PACKAGES) -c $<

%.cmi: %.mli
	ocamlfind ocamlc $(SAFESTRING) -package $(PACKAGES) -c $<

annot_parser.ml: annot_parser.mli
annot_parser.mli: annot_parser.mly
	menhir --infer --explain $<

js_parser.ml: js_parser.mli
js_parser.mli: js_parser.mly
	menhir --infer --external-tokens Js_token --explain $<

%.ml: %.mll
	ocamllex $<
clean:
	rm -f *.cm[aiox] *.cmxa *.cmxs *.o *.a *.conflicts
	rm -f compile.opt compile.byte minify.opt minify.byte
	rm -f $(MINIFIER) $(COMPILER)
	rm -f compiler_version.ml
	rm -f annot_lexer.ml annot_parser.ml annot_parser.mli
	rm -f js_lexer.ml js_parser.ml js_parser.mli
	rm -Rf man

.PHONY: depend
depend: compiler_version.ml annot_lexer.ml js_lexer.ml js_parser.ml annot_parser.ml
	ocamldep *.ml *.mli > .depend

include .depend

=== doc/Makefile ===

include ../Makefile.conf
-include ../Makefile.local
include ../Makefile.filelist

MLIS := ${addprefix ../, ${DOC}}

ifeq "${WITH_GRAPHICS}" "YES"
OTHER=-package graphics -I ../lib/graphics
endif

ifeq "${WITH_DERIVING}" "YES"
OTHER += -package deriving.syntax.common
endif

ifeq "${WITH_TYXML}${WITH_REACT}" "YESYES"
OTHER += -package tyxml.functor,react,reactiveData -I ../lib/tyxml
endif

ifeq "${WITH_TOPLEVEL}" "YES"
OTHER += -package compiler-libs.bytecomp,compiler-libs.common,compiler-libs.toplevel -I ../lib/toplevel
endif

.PHONY: doc wikidoc
doc: api/html/index.html
api/html/index.html: ${MLIS} api/index
	mkdir -p api/html
	ocamlfind ocamldoc ${DOCOPT} -package lwt,ocamlbuild ${OTHER} -intro api/index -html \
	   -d api/html -I ../lib -I ../lib/deriving_json ${MLIS}

wikidoc: api/wiki/index.wiki cp-examples
api/wiki/index.wiki: ${MLIS} api/index
	mkdir -p api/wiki
	ocamlfind ocamldoc ${DOCOPT} -package lwt,ocamlbuild ${OTHER} -intro api/index \
	   -d api/wiki -I ../lib -I ../lib/deriving_json -I ../lib/syntax \
	   -i $(shell ocamlfind query wikidoc) -g odoc_wiki.cma \
	   ${MLIS}

EX_TOPLEVEL:=index.html toplevel.js *.cmis.js
EX_BOULDER:=index.html boulderdash.js sprites
EX_WEBGL:=index.html webgldemo.js
EX_GRAPH:=index.html jsviewer.js
EX_PLANET:=index.html texture.jpg planet.js
EX_WIKI:=index.html wiki.js
EX_WYSIWYG:=index.html wiki.js
EX_HYPER:=index.html hypertree.js icons thumbnails svg_icons
EX_MINE:=index.html minesweeper.js sprites
EX_CUBE:=index.html cubes.js

cp-examples:
	$(MAKE) -C .. toplevel examples
	mkdir -p ${addprefix manual/files/, toplevel/ boulderdash/ webgl/ graph_viewer/ planet/ wiki/ wysiwyg/ minesweeper/ cubes/ hyperbolic/}
	cp -R ${addprefix ../toplevel/, ${EX_TOPLEVEL}} manual/files/toplevel/
	cp -R ${addprefix ../examples/boulderdash/, ${EX_BOULDER}} manual/files/boulderdash/
	cp -R ${addprefix ../examples/webgl/, ${EX_WEBGL}} manual/files/webgl/
	cp -R ${addprefix ../examples/graph_viewer/, ${EX_GRAPH}} manual/files/graph_viewer/
	cp -R ${addprefix ../examples/planet/, ${EX_PLANET}} manual/files/planet/
	cp -R ${addprefix ../examples/wiki/, ${EX_WIKI}} manual/files/wiki/
	cp -R ${addprefix ../examples/wysiwyg/, ${EX_WYSIWYG}} manual/files/wysiwyg/
	cp -R ${addprefix ../examples/minesweeper/, ${EX_MINE}} manual/files/minesweeper/
	cp -R ${addprefix ../examples/cubes/, ${EX_CUBE}} manual/files/cubes/
	cp -R ${addprefix ../examples/hyperbolic/, ${EX_HYPER}} manual/files/hyperbolic/

clean:
	-rm -rf api/html/* api/wiki/*

=== examples/Makefile ===

TARGETS=*/

.PHONY: $(TARGETS)

all: $(TARGETS)

$(TARGETS):
	$(MAKE) -C $@

clean:
	for i in $(TARGETS); do $(MAKE) -C $$i clean; done

=== jsoo_tools/Makefile ===
include ../Makefile.conf
-include ../Makefile.local

ifeq "${WITH_TOPLEVEL}" "YES"
ALL= $(MKTOP) $(MKCMIS)
endif

all: $(ALL)

$(MKTOP): jsoo_mktop.$(BEST)
	cp $< $@
$(MKCMIS): jsoo_mkcmis.$(BEST)
	cp $< $@

byte: jsoo_mkcmis.byte jsoo_mktop.byte
opt: jsoo_mkcmis.opt jsoo_mktop.opt

%.cmo: %.ml
%.cmx: %.ml
jsoo_mktop.cmo jsoo_mkcmis.cmo: jsoo_common.cmo
jsoo_mktop.cmx jsoo_mkcmis.cmx: jsoo_common.cmx
jsoo_common.cmo jsoo_common.cmx: ../compiler/compiler.cmi

%.byte: ../compiler/compiler.cma jsoo_common.cmo %.cmo
	ocamlfind ocamlc -linkpkg -g $(SAFESTRING) \
	-package compiler-libs.common,findlib \
	$^ -o $*.byte

%.opt: ../compiler/compiler.cmxa jsoo_common.cmx %.cmx
	ocamlfind ocamlopt -linkpkg -g $(SAFESTRING) \
	-package compiler-libs.common,findlib \
	$^ -o $*.opt

%.cmo: %.ml
	ocamlfind ocamlc -c -g $(SAFESTRING) \
	-package compiler-libs.common,findlib \
	-I ../compiler/ $<

%.cmx: %.ml
	ocamlfind ocamlopt -c -g $(SAFESTRING) \
	-package compiler-libs.common,findlib \
	-I ../compiler/ $<

clean:
	rm -f *.cm[xioa] *.[ao] *.so *.cmx[sa] *.byte *.opt $(MKTOP) $(MKCMIS)

=== lib/Makefile ===
MLOBJS= js.cmo dom.cmo typed_array.cmo dom_html.cmo dom_svg.cmo file.cmo dom_events.cmo firebug.cmo lwt_js.cmo sys_js.cmo regexp.cmo cSS.cmo url.cmo form.cmo xmlHttpRequest.cmo lwt_js_events.cmo json.cmo jsonp.cmo webGL.cmo webSockets.cmo keycode.cmo eventSource.cmo
MLINTFS= $(MLOBJS:.cmo=.mli)
COBJS= stubs$(OBJEXT)
OBJS=$(MLOBJS) $(COBJS)

JSON_OBJS=$(addprefix deriving_json/,deriving_Json_lexer.cmo deriving_Json.cmo)

include ../Makefile.conf
-include ../Makefile.local

ifeq "${WITH_DERIVING}" "YES"
PA_DERIVING=syntax/pa_deriving_Json.cmo
DERIVING_JSON=deriving_json.cma
ifeq "$(BEST)" "opt"
DERIVING_JSON += deriving_json.cmxs
ifeq "${NATDYNLINK}" "YES"
PA_DERIVING_NDL= syntax/pa_deriving_Json.cmx syntax/pa_deriving_Json.cmxs
endif
endif
endif

ifeq "${WITH_GRAPHICS}" "YES"
GRAPHICS_CMA=graphics/graphics.cma
endif

ifeq "${WITH_TYXML}${WITH_REACT}" "YESYES"
TYXML_CMA=tyxml/tyxml.cma
endif

ifeq "${WITH_TOPLEVEL}" "YES"
TOPLEVELLIB= toplevel/jsooTop.cmo
endif

PA_JS= syntax/pa_js.cmo
ifeq "${BEST}" "opt"
ifeq "${NATDYNLINK}" "YES"
PA_JS_NDL= syntax/pa_js.cmx syntax/pa_js.cmxs
endif
endif

all: $(LIBNAME).cma log/logger.cma \
	${PA_JS} ${PA_JS_NDL} \
	${PA_DERIVING} 	${PA_DERIVING_NDL} \
	${DERIVING_JSON} \
	${GRAPHICS_CMA} \
	${TYXML_CMA}

$(LIBNAME).cma: $(OBJS)
	ocamlmklib -o $(LIBNAME) $(OBJS)

deriving_json.cma: $(JSON_OBJS)
	ocamlfind ocamlc -a -o $@ $^

deriving_json.cmxa: $(JSON_OBJS:.cmo=.cmx)
	ocamlfind ocamlopt -a -o $@ $^
deriving_json.cmxs: deriving_json.cmxa
	ocamlfind ocamlopt -shared -linkall -o $@ $^

syntax/pa_js.cmo: syntax/pa_js.ml
	ocamlfind ocamlc $(SAFESTRING) -package camlp4.extend,camlp4.quotations -syntax camlp4o -c $<

syntax/pa_js.cmx: syntax/pa_js.ml
	ocamlfind ocamlopt $(SAFESTRING) -package camlp4.extend,camlp4.quotations -syntax camlp4o -c $<

syntax/pa_js.cmxs: syntax/pa_js.cmx
	ocamlfind ocamlopt -shared -linkall -o $@ $<

syntax/pa_deriving_Json.cmo: syntax/pa_deriving_Json.ml syntax/pa_deriving_Json.cmi
	ocamlfind ocamlc -I syntax $(SAFESTRING) -package deriving.syntax.common,camlp4.quotations.o -syntax camlp4o -c $<

syntax/pa_deriving_Json.cmi: syntax/pa_deriving_Json.mli
	ocamlfind ocamlc $(SAFESTRING) -package deriving.syntax.common,camlp4.quotations.o -syntax camlp4o -c $<

syntax/pa_deriving_Json.cmx: syntax/pa_deriving_Json.ml
	ocamlfind ocamlopt -I syntax $(SAFESTRING) -package deriving.syntax.common,camlp4.quotations.o -syntax camlp4o -c $<

syntax/pa_deriving_Json.cmxs: syntax/pa_deriving_Json.cmx
	ocamlfind ocamlopt -I syntax -shared -linkall -o $@ $<

graphics/%.cmo: graphics/%.ml graphics/%.cmi syntax/pa_js.cmo
	ocamlfind ocamlc -syntax camlp4o $(SAFESTRING) -package lwt,lwt.syntax,graphics -ppopt syntax/pa_js.cmo -I graphics -c $< -o $@

graphics/%.cmi: graphics/%.mli
	ocamlfind ocamlc $(SAFESTRING) -package lwt,graphics -I ./ $< -o $@

graphics/graphics.cma: graphics/graphics_js.cmo
	ocamlfind ocamlc -a -o $@ $^

tyxml/%.cmo: tyxml/%.ml tyxml/%.cmi tyxml/tyxml_cast_sigs.cmi syntax/pa_js.cmo
	ocamlfind ocamlc -syntax camlp4o $(SAFESTRING) -package lwt,lwt.syntax,tyxml.functor,reactiveData,react -ppopt syntax/pa_js.cmo -I tyxml -c $< -o $@

tyxml/tyxml_cast_sig.cmi: tyxml/tyxml_cast_sig.mli
	ocamlfind ocamlc $(SAFESTRING) -package lwt,tyxml.functor,reactiveData,react -I . -I tyxml $< -o $@

tyxml/%.cmi: tyxml/%.mli tyxml/tyxml_cast_sigs.cmi
	ocamlfind ocamlc $(SAFESTRING) -package lwt,tyxml.functor,reactiveData,react -I . -I tyxml $< -o $@

tyxml/tyxml.cma: tyxml/tyxml_cast.cmo tyxml/tyxml_js.cmo
	ocamlfind ocamlc -a -o $@ $^


log/%.cmo: log/%.ml log/%.cmi syntax/pa_js.cmo
	ocamlfind ocamlc -syntax camlp4o $(SAFESTRING) -package lwt,lwt.syntax,lwt.log -ppopt syntax/pa_js.cmo -I log -c $< -o $@

log/%.cmi: log/%.mli
	ocamlfind ocamlc $(SAFESTRING) -package lwt,lwt.log -I . -I log $< -o $@

log/logger.cma: log/lwt_log_js.cmo
	ocamlfind ocamlc -a -o $@ $^

toplevel_lib: $(TOPLEVELLIB)

toplevel/jsooTop.cmo: toplevel/jsooTop.ml toplevel/jsooTop.cmi syntax/pa_js.cmo ../compiler/compiler.cma
	ocamlfind ocamlc -syntax camlp4o \
		$(SAFESTRING) -package lwt,lwt.syntax \
		-ppopt syntax/pa_js.cmo \
		-I toplevel -I ../compiler -I +compiler-libs \
		-c $< -o $@

toplevel/jsooTop.cmi: toplevel/jsooTop.mli
	ocamlfind ocamlc $(SAFESTRING) -package lwt -I . -I log $< -o $@


%.cmo: %.ml syntax/pa_js.cmo
	ocamlfind ocamlc -pp "camlp4o syntax/pa_js.cmo" $(SAFESTRING) -package lwt -c -g $<

sys_js.ml: sys_js.mlp
	sed -e "s|%%VERSION%%|`sed -e 1q ../VERSION`|" sys_js.mlp >sys_js.ml

%.cmi: %.mli
	ocamlfind ocamlc -package lwt -I deriving_json $(SAFESTRING) -c $<

%.ml: %.mll
	ocamllex $<

${JSON_OBJS}: %.cmo: %.ml ${PA_DERIVING}
	ocamlfind ocamlc $(SAFESTRING) -package deriving.syntax.common -syntax camlp4o -ppopt ${PA_DERIVING} -I deriving_json -c $<

${JSON_OBJS:.cmo=.cmx}: %.cmx: %.ml ${PA_DERIVING}
	ocamlfind ocamlopt $(SAFESTRING) -package deriving.syntax.common -syntax camlp4o -ppopt ${PA_DERIVING} -I deriving_json -c $<

%$(OBJEXT): %.c
	ocamlfind ocamlc -package lwt -c $<

stubs.c: $(MLOBJS:cmo=ml)
	(echo "#include <stdlib.h>"; \
	 echo "#include <stdio.h>"; \
	 echo "#define D(f) void f () { fprintf(stderr, \"Unimplemented Javascript primitive %s!\\\\n\", #f); exit(1); }"; \
	 (sed -n -e 's/.*external.*"\([^"%]*\)".*/D(\1)/p' $(MLOBJS:cmo=ml) | \
	  sort | uniq)) \
        > stubs.c

clean:
	rm -f *.cm[xioa] *.[ao] *.so *.cmx[sa]
	rm -f syntax/*.cm[xioa] syntax/*.[ao] syntax/*.so syntax/*.cmx[sa]
	rm -f log/*.cm[xioa] log/*.[ao] log/*.so log/*.cmx[sa]
	rm -f tyxml/*.cm[xioa] tyxml/*.[ao] tyxml/*.so tyxml/*.cmx[sa]
	rm -f graphics/*.cm[xioa] graphics/*.[ao] graphics/*.so graphics/*.cmx[sa]
	rm -f toplevel/*.cm[xioa] toplevel/*.[ao] toplevel/*.so toplevel/*.cmx[sa]
	rm -f deriving_json/*.cm[xioa] deriving_json/*.[ao] deriving_json/*.so
	rm -f deriving_json/deriving_Json_lexer.ml
	rm -f stubs.c
	rm -f sys_js.ml

depend: syntax/pa_js.cmo ${PA_DERIVING} sys_js.ml
	ocamldep -pp "camlp4o syntax/pa_js.cmo" *.ml *.mli > .depend
	ocamldep -pp "camlp4o syntax/pa_js.cmo" log/*.ml log/*.mli >> .depend
	ocamldep -pp "camlp4o syntax/pa_js.cmo" toplevel/*.ml toplevel/*.mli >> .depend
ifeq "${WITH_GRAPHICS}" "YES"
	ocamldep -pp "camlp4o syntax/pa_js.cmo" graphics/*.ml  >> .depend
	@# camlp4 3.12.0 fails on (module type of ...)
	ocamldep -I graphics graphics/graphics_js.mli  >> .depend
endif
ifeq "${WITH_TYXML}${WITH_REACT}" "YESYES"
	ocamldep -pp "camlp4o syntax/pa_js.cmo" tyxml/*.ml tyxml/*.mli >> .depend
endif
ifeq "${WITH_DERIVING}" "YES"
	${MAKE} --no-print-directory deriving_json/deriving_Json_lexer.ml
	ls deriving_json/*.mli deriving_json/*.ml | \
	  grep -v deriving_Json_stdlib.mli | \
	  xargs ocamlfind ocamldep -I deriving_json -package deriving.syntax.common -syntax camlp4o -ppopt ${PA_DERIVING} >> .depend
	@# camlp4 3.12.0 fails on (module type of ...)
	ocamldep -I deriving_json deriving_json/deriving_Json_stdlib.mli  >> .depend
endif

include .depend

=== ocamlbuild/Makefile ===

include ../Makefile.conf
-include ../Makefile.filelist

OCAMLBUILD := ocamlbuild -use-ocamlfind -package bytes

all:
	$(OCAMLBUILD) $(OCAMLBUILD_IMPL)

clean:
	$(OCAMLBUILD) -clean

=== runtime/Makefile ===
FILES= 	mlString.js ieee_754.js int64.js md5.js marshal.js \
	lexing.js parsing.js bigarray.js unix.js \
	stdlib.js io.js fs.js jslib.js jslib_js_of_ocaml.js \
	internalMod.js gc.js polyfill/json.js

runtime.js: $(FILES)
	echo "//concat $(FILES)" > runtime.js
	for f in $(FILES) ; do \
		 echo "//# 1 \"$$f\"" >> runtime.js; \
	   cat $$f >> runtime.js; \
	done

clean:
	rm -f runtime.js

=== tests/Makefile ===
include Makefile.common

TESTS_SRC=$(wildcard dir/*.ml)
TESTS_CMO=$(TESTS_SRC:.ml=.cmo)
TESTS_BYTE=$(TESTS_SRC:.ml=.byte)
TESTS_JS=$(TESTS_SRC:.ml=.js)
TESTS_LOG=$(TESTS_SRC:.ml=.log)

COMMON=common.cmo

all: $(COMMON) $(TESTS_CMO) $(TESTS_BYTE) $(TESTS_JS) tests.byte

phantom_check::
	@which phantomjs || (echo "You need phantomjs in your PATH to run this" && false)

clear_test::
	@rm -f dir/*.log dir/*.log.err

phantom: phantom_check clear_test all $(TESTS_LOG)

tests.byte: $(TESTS_CMO) $(COMMON)
	@$(OCAMLC) -linkpkg $(STDLIB) ../lib/deriving_json.cma common.cmo -package unix $(TESTS_CMO) -o tests.byte

%.log: %.js
	@(phantomjs $^ > $@ && head -n 1 $@) || (echo "Error for " $^ "\n" && mv $@ $@.err && cat $@.err)

clean:
	rm -f *.cm[io] *.byte *.js dir/*.cm[io] dir/*.byte dir/*.js dir/*.log

=== toplevel/Makefile ===
include ../Makefile.conf
-include ../Makefile.local

all: toplevel.js eval.js


OCPINDENT=$(shell ocamlfind query ocp-indent -format "-package %p.lib" 2> /dev/null)
HIGLO=$(shell ocamlfind query higlo.ocaml -format "-package %p -rectypes" 2> /dev/null)

OPTCOMP_OPT=
ifneq ($(OCPINDENT),)
OPTCOMP_OPT+= -let ocpindent=true
endif

ifneq ($(HIGLO),)
OPTCOMP_OPT+= -let higlo=true
endif

ifneq ($(NO_SYNTAXES),1)
SYNTAXES= lwt.syntax \
	js_of_ocaml.syntax \
	js_of_ocaml.deriving.syntax deriving.syntax.std
endif

JSFILES= +weak.js +toplevel.js +graphics.js +nat.js

PACKAGES= \
	graphics lwt bigarray tyxml.functor \
	react reactiveData \
	js_of_ocaml \
	js_of_ocaml.deriving \
	js_of_ocaml.tyxml \
	js_of_ocaml.graphics \
	js_of_ocaml.toplevel

ifeq ($(METAOCAML),1)
BER_EXPORT=trx runcode print_code
BER=metalib.cma bertop.cmo \
	${addprefix -export-unit , ${BER_EXPORT}}
#METAOCAML DOES NOT WORK WITH CAMLP4
SYNTAXES=
OPTCOMP_OPT+= -let metaocaml=true
endif

#-jsopt "--pretty --disable shortvar"
MKTOP=jsoo_mktop -verbose $(SAFESTRING) \
	${addprefix -top-syntax , ${SYNTAXES}} \
	-dont-export-unit gc \
	${addprefix -export-package , ${PACKAGES}} \
	${addprefix -export-unit , html5_types html5_sigs xml_wrap } \

TOPLEVEL_NAME=toplevel
TOPLEVEL_OBJS=toplevel.cmo
$(TOPLEVEL_NAME).js: $(TOPLEVEL_OBJS)
	$(MKTOP) \
	$(BER) \
	$(OCPINDENT) $(HIGLO) \
	$(TOPLEVEL_OBJS) \
	${addprefix -jsopt , ${JSFILES}} \
	${addprefix -jsopt , -I ./ --file examples.ml} \
	-package base64 \
	-o $(TOPLEVEL_NAME).byte

EVAL_NAME=eval
EVAL_OBJS=eval.cmo
$(EVAL_NAME).js: $(EVAL_OBJS)
	$(MKTOP) $(EVAL_OBJS) \
	${addprefix -jsopt , ${JSFILES}} \
	-o $(EVAL_NAME).byte

%.cmis.js:
	jsoo_mkcmis $*

server.%: server.ml
	ocamlbuild -use-ocamlfind -package findlib,cohttp.lwt server.$*

%.cmo:%.ml
	ocamlfind ocamlc -c -syntax camlp4o $(SAFESTRING) \
		-package optcomp,js_of_ocaml.syntax,lwt,js_of_ocaml.tyxml,js_of_ocaml.toplevel \
		-package base64 \
		$(OCPINDENT) $(HIGLO) \
		${addprefix -ppopt , ${OPTCOMP_OPT}} \
		$< -c $@
clean::
	rm -f *.cm[io] *.byte *.native *.js

=== examples/boulderdash/Makefile ===
OBJS=boulderdash.cmo
NAME=boulderdash
OPTIONS=-I ../../examples/boulderdash/ --file maps.txt:/ --file maps:/
include ../Makefile.common

=== debian/changelog ===
js-of-ocaml (2.5-2) unstable; urgency=medium

  * Build with reactiveData and tyxml support

 -- Stéphane Glondu <glondu@debian.org>  Fri, 06 Nov 2015 16:10:18 +0100

js-of-ocaml (2.5-1) unstable; urgency=medium

  * Team upload
  * New upstream release
    - Remove 0001-Fix-generation-of-compiler.cm.patch, integrated upstream.
    - Refresh remaining patch
    - Add libcmdliner-ocaml-dev and libfindlib-ocaml-dev to Build-Depends.
  * Fix install target
  * Install logger.cma and jsooTop.cmo in libjs-of-ocaml

 -- Mehdi Dogguy <mehdi@debian.org>  Sun, 18 Oct 2015 10:41:57 +0200

=== debian/control ===
Source: js-of-ocaml
Section: ocaml
Priority: optional
Maintainer: Debian OCaml Maintainers <debian-ocaml-maint@lists.debian.org>
Uploaders: Stéphane Glondu <glondu@debian.org>, Nicolas Dandrimont <nicolas.dandrimont@crans.org>
Build-Depends:
 debhelper (>= 8),
 dh-ocaml (>= 0.9~),
 ocaml-findlib (>= 1.4),
 liblwt-ocaml-dev (>= 2.4),
 libderiving-ocsigen-ocaml-dev (>= 0.6),
 libcmdliner-ocaml-dev,
 libfindlib-ocaml-dev,
 libreactivedata-ocaml-dev,
 libtyxml-ocaml-dev,
 camlp4,
 menhir,
 ocaml-nox (>= 4.01)
Standards-Version: 3.9.5
Homepage: http://ocsigen.org/js_of_ocaml
Vcs-Browser: http://anonscm.debian.org/gitweb/?p=pkg-ocaml-maint/packages/js-of-ocaml.git
Vcs-Git: git://anonscm.debian.org/pkg-ocaml-maint/packages/js-of-ocaml.git

Package: js-of-ocaml
Architecture: any
Depends:
 libjs-of-ocaml-dev,
 ${ocaml:Depends},
 ${shlibs:Depends},
 ${misc:Depends}
Provides: ${ocaml:Provides}
Recommends: ocaml-findlib
Description: OCaml bytecode to JavaScript compiler (compiler)
 Js_of_ocaml is a compiler of OCaml bytecode to JavaScript. It makes
 it possible to run OCaml programs in a web browser. Its key features
 are the following:
  * the whole language, and most of the standard library are
    supported;
  * the generated code can be used with any web server and browser;
  * you can use a standard installation of OCaml to compile your
    programs. In particular, you do not have to recompile a library to
    use it with Js_of_ocaml. You just have to link your program with a
    specific library to interface with the browser APIs.
 .
 This package contains the compiler itself.

Package: libjs-of-ocaml-dev
Architecture: any
Depends:
 ${ocaml:Depends},
 ${shlibs:Depends},
 ${misc:Depends}
Breaks: libjs-of-ocaml (<< 1.4)
Replaces: libjs-of-ocaml (<< 1.4)
Provides: ${ocaml:Provides}
Recommends: ocaml-findlib
Description: OCaml bytecode to JavaScript compiler (development files)
 Js_of_ocaml is a compiler of OCaml bytecode to JavaScript. It makes
 it possible to run OCaml programs in a web browser. Its key features
 are the following:
  * the whole language, and most of the standard library are
    supported;
  * the generated code can be used with any web server and browser;
  * you can use a standard installation of OCaml to compile your
    programs. In particular, you do not have to recompile a library to
    use it with Js_of_ocaml. You just have to link your program with a
    specific library to interface with the browser APIs.
 .
 This package contains development files needed to compile server-side
 (using regular OCaml compiler) and client-side (using Js_of_ocaml)
 programs.

Package: libjs-of-ocaml
Architecture: any
Depends:
 ${ocaml:Depends},
 ${shlibs:Depends},
 ${misc:Depends}
Breaks: libjs-of-ocaml-dev (<< 1.4)
Replaces: libjs-of-ocaml-dev (<< 1.4)
Provides: ${ocaml:Provides}
Recommends: ocaml-findlib
Description: OCaml bytecode to JavaScript compiler (runtime)
 Js_of_ocaml is a compiler of OCaml bytecode to JavaScript. It makes
 it possible to run OCaml programs in a web browser. Its key features
 are the following:
  * the whole language, and most of the standard library are
    supported;
  * the generated code can be used with any web server and browser;
  * you can use a standard installation of OCaml to compile your
    programs. In particular, you do not have to recompile a library to
    use it with Js_of_ocaml. You just have to link your program with a
    specific library to interface with the browser APIs.
 .
 This package contains runtime libraries that may be needed by
 server-side programs communicating with clients compiled with
 Js_of_ocaml using JSON.

Package: libjs-of-ocaml-doc
Section: doc
Architecture: all
Depends: ${misc:Depends}
Description: OCaml bytecode to JavaScript compiler (documentation)
 Js_of_ocaml is a compiler of OCaml bytecode to JavaScript. It makes
 it possible to run OCaml programs in a web browser.
 .
 This package contains the API reference and examples.

=== debian/rules ===
#!/usr/bin/make -f
# -*- makefile -*-

DESTDIR=$(CURDIR)/debian/tmp
BINDIR=$(DESTDIR)/usr/bin
DOCDIR=$(DESTDIR)/usr/share/doc/libjs-of-ocaml-dev

include /usr/share/ocaml/ocamlvars.mk

export OCAMLFIND_DESTDIR=$(DESTDIR)/$(OCAML_STDLIB_DIR)
export OCAMLFIND_LDCONF=ignore

%:
	dh $@ --with ocaml

.PHONY: override_dh_install
override_dh_install:
	dh_install -X.so.owner --fail-missing

.PHONY: override_dh_compress
override_dh_compress:
	dh_compress -X.js

.PHONY: override_dh_auto_build
override_dh_auto_build:
	$(MAKE) BEST=$(OCAML_BEST)

.PHONY: override_dh_auto_install
override_dh_auto_install:
	mkdir -p $(OCAMLFIND_DESTDIR) $(BINDIR) $(DESTDIR)$(OCAML_DLL_DIR)
	$(MAKE) install BINDIR=$(BINDIR) BEST=$(OCAML_BEST)
	mkdir -p $(DOCDIR)/html $(DOCDIR)/examples
	cp -a doc/api/html $(DOCDIR)/html/api
	cp -a examples/* $(DOCDIR)/examples
	rm -f $(DOCDIR)/examples/*/*.cm* $(DOCDIR)/examples/*/*.byte
ifeq ($(OCAML_NATDYNLINK),no)
	find $(DESTDIR) -name '*.cmxs' -delete
endif

.PHONY: override_dh_auto_clean
override_dh_auto_clean:
	dh_auto_clean
	-cd $(CURDIR)/doc && make clean
	rm -Rf doc/api/html/

=== debian/watch ===
version=3
http://ocsigen.org/js_of_ocaml/install .*/archive/(.*)\.tar\.gz

## js-of-ocaml 3.5.2

=== debian/changelog ===
js-of-ocaml (3.5.2-3) unstable; urgency=medium

  * Avoid an unfortunate wildcard that was installing the same file in
    libjs-of-ocaml and in libjs-of-ocaml-dev, causing failure of their
    installation

 -- Stéphane Glondu <glondu@debian.org>  Fri, 14 Feb 2020 09:51:30 +0100

js-of-ocaml (3.5.2-2) unstable; urgency=medium

  * Fix FTBFS on bytecode architectures

 -- Stéphane Glondu <glondu@debian.org>  Tue, 11 Feb 2020 12:53:39 +0100

js-of-ocaml (3.5.2-1) unstable; urgency=medium

  [ Stéphane Glondu ]
  * New upstream release (Closes: #878469)
  * Update debian/watch
  * Update Vcs-*
  * Bump debhelper compat level to 12
  * Bump Standards-Version to 4.5.0
  * Add Rules-Requires-Root: no

  [ Nicolas Dandrimont ]
  * d/control: remove myself from Uploaders

 -- Stéphane Glondu <glondu@debian.org>  Tue, 11 Feb 2020 09:45:15 +0100

=== debian/control ===
--- 
+++ 
@@ -2,24 +2,30 @@
 Section: ocaml
 Priority: optional
 Maintainer: Debian OCaml Maintainers <debian-ocaml-maint@lists.debian.org>
-Uploaders: Stéphane Glondu <glondu@debian.org>, Nicolas Dandrimont <nicolas.dandrimont@crans.org>
+Uploaders: Stéphane Glondu <glondu@debian.org>
 Build-Depends:
- debhelper (>= 8),
- dh-ocaml (>= 0.9~),
- ocaml-findlib (>= 1.4),
- liblwt-ocaml-dev (>= 2.4),
- libderiving-ocsigen-ocaml-dev (>= 0.6),
+ debhelper-compat (= 12),
+ ocaml,
+ ocaml-dune,
+ ocaml-findlib,
+ ocamlbuild,
+ libfindlib-ocaml-dev,
  libcmdliner-ocaml-dev,
- libfindlib-ocaml-dev,
- libreactivedata-ocaml-dev,
- libtyxml-ocaml-dev,
- camlp4,
- menhir,
- ocaml-nox (>= 4.01)
-Standards-Version: 3.9.5
+ libmigrate-parsetree-ocaml-dev (>= 1.4),
+ libppx-tools-versioned-ocaml-dev (>= 5.2.3),
+ libppxlib-ocaml-dev (>= 0.9.0),
+ libyojson-ocaml-dev,
+ libuchar-ocaml-dev,
+ liblwt-ocaml-dev,
+ liblwt-log-ocaml-dev,
+ libtyxml-ocaml-dev (>= 4.3),
+ libreactivedata-ocaml-dev (>= 0.2),
+ dh-ocaml
+Standards-Version: 4.5.0
+Rules-Requires-Root: no
 Homepage: http://ocsigen.org/js_of_ocaml
-Vcs-Browser: http://anonscm.debian.org/gitweb/?p=pkg-ocaml-maint/packages/js-of-ocaml.git
-Vcs-Git: git://anonscm.debian.org/pkg-ocaml-maint/packages/js-of-ocaml.git
+Vcs-Browser: https://salsa.debian.org/ocaml-team/js-of-ocaml
+Vcs-Git: https://salsa.debian.org/ocaml-team/js-of-ocaml.git
 
 Package: js-of-ocaml
 Architecture: any

=== debian/rules ===
#!/usr/bin/make -f
# -*- makefile -*-

DESTDIR=$(CURDIR)/debian/tmp

include /usr/share/ocaml/ocamlvars.mk

export OCAMLPATH := $(CURDIR)/_tmp$(OCAML_STDLIB_DIR)
export PATH := $(CURDIR)/_tmp/usr/bin:$(PATH)

DUNE_INSTALL := dune install --destdir=$(CURDIR)/_tmp --prefix=/usr --libdir=..$(OCAML_STDLIB_DIR)

%:
	dh $@ --with ocaml

override_dh_auto_clean:
	dh_auto_clean
	rm -rf _tmp

override_dh_auto_build:
	dune build -p js_of_ocaml-compiler
	$(DUNE_INSTALL) js_of_ocaml-compiler
	dune build -p js_of_ocaml
	$(DUNE_INSTALL) js_of_ocaml
	dune build -p js_of_ocaml-ppx
	$(DUNE_INSTALL) js_of_ocaml-ppx
	dune build -p js_of_ocaml-ppx_deriving_json
	$(DUNE_INSTALL) js_of_ocaml-ppx_deriving_json
	dune build -p js_of_ocaml-lwt
	$(DUNE_INSTALL) js_of_ocaml-lwt
	dune build -p js_of_ocaml-ocamlbuild
	$(DUNE_INSTALL) js_of_ocaml-ocamlbuild
	dune build -p js_of_ocaml-toplevel
	$(DUNE_INSTALL) js_of_ocaml-toplevel
	dune build -p js_of_ocaml-tyxml
	$(DUNE_INSTALL) js_of_ocaml-tyxml

override_dh_auto_test:
# Needs ppx-expect

override_dh_auto_install:
	rm -rf debian/tmp
	cp -a _tmp debian/tmp
	for u in js_of_ocaml-compiler js_of_ocaml-ppx js_of_ocaml-ppx_deriving_json js_of_ocaml-lwt js_of_ocaml-ocamlbuild js_of_ocaml-toplevel js_of_ocaml-tyxml; do \
	  rm -rf debian/tmp/usr/doc/$$u; \
	done
	rm -f debian/tmp/usr/doc/js_of_ocaml/LICENSE

override_dh_missing:
	dh_missing --fail-missing

=== debian/watch ===
version=3
https://github.com/ocsigen/js_of_ocaml/releases .*/archive/(.*)\.tar\.gz

## js-of-ocaml 3.7.0

=== debian/changelog ===
js-of-ocaml (3.7.0-2build1) groovy; urgency=medium

  * Rebuild against new OCAML ABI.

 -- Gianfranco Costamagna <locutusofborg@debian.org>  Tue, 01 Sep 2020 13:44:13 +0200

js-of-ocaml (3.7.0-2) unstable; urgency=medium

  * Fix compilation on bytecode architectures

 -- Stéphane Glondu <glondu@debian.org>  Sat, 22 Aug 2020 21:17:47 +0200

js-of-ocaml (3.7.0-1) unstable; urgency=medium

  * New upstream release

 -- Stéphane Glondu <glondu@debian.org>  Sat, 22 Aug 2020 19:50:03 +0200

js-of-ocaml (3.6.0-2) unstable; urgency=medium

  * Fix FTBFS on bytecode architectures

 -- Stéphane Glondu <glondu@debian.org>  Wed, 29 Jul 2020 14:35:34 +0200

js-of-ocaml (3.6.0-1) unstable; urgency=medium

  * New upstream release
  * Bump debhelper compat level to 13

 -- Stéphane Glondu <glondu@debian.org>  Wed, 29 Jul 2020 10:12:17 +0200

=== debian/control ===
--- 
+++ 
@@ -4,22 +4,24 @@
 Maintainer: Debian OCaml Maintainers <debian-ocaml-maint@lists.debian.org>
 Uploaders: Stéphane Glondu <glondu@debian.org>
 Build-Depends:
- debhelper-compat (= 12),
+ debhelper-compat (= 13),
  ocaml,
- ocaml-dune,
+ ocaml-dune (>= 2.5),
  ocaml-findlib,
  ocamlbuild,
  libfindlib-ocaml-dev,
  libcmdliner-ocaml-dev,
  libmigrate-parsetree-ocaml-dev (>= 1.4),
  libppx-tools-versioned-ocaml-dev (>= 5.2.3),
- libppxlib-ocaml-dev (>= 0.9.0),
+ libppxlib-ocaml-dev (>= 0.14.0),
  libyojson-ocaml-dev,
  libuchar-ocaml-dev,
  liblwt-ocaml-dev,
  liblwt-log-ocaml-dev,
  libtyxml-ocaml-dev (>= 4.3),
  libreactivedata-ocaml-dev (>= 0.2),
+ menhir,
+ libmenhir-ocaml-dev,
  dh-ocaml
 Standards-Version: 4.5.0
 Rules-Requires-Root: no

=== debian/rules ===
--- 
+++ 
@@ -18,6 +18,11 @@
 	rm -rf _tmp
 
 override_dh_auto_build:
+	rm -f compiler/tests-jsoo/dune         # makes the build fail on amd64
+	rm -f compiler/lib-runtime/tests/dune  # makes the build fail on bytecode architectures
+ifeq ($(OCAML_HAVE_OCAMLOPT),no)
+	sed -i 's/ native//' compiler/bin-js_of_ocaml/dune
+endif
 	dune build -p js_of_ocaml-compiler
 	$(DUNE_INSTALL) js_of_ocaml-compiler
 	dune build -p js_of_ocaml
@@ -46,5 +51,4 @@
 	done
 	rm -f debian/tmp/usr/doc/js_of_ocaml/LICENSE
 
-override_dh_missing:
-	dh_missing --fail-missing
+override_dh_dwz:

## js-of-ocaml 3.8.0

=== Makefile ===
all:
	dune build @install @default -j 8

tests:
	dune runtest

test runtest runtests: tests

doc:
	dune build @ocsigen-doc

promote:
	dune promote

fmt:
	dune build @fmt --auto-promote 2> /dev/null || true
	git diff --exit-code

clean:
	dune clean

installdoc:
	rm -rf _wikidoc
	git clone ./ _wikidoc
	(cd _wikidoc && git checkout wikidoc)
	rm -rf _wikidoc/doc/dev/*
	cp -r _build/default/_doc/_html _wikidoc/doc/dev/api
	cp -r _build/default/manual _wikidoc/doc/dev/manual
	find _wikidoc/doc/dev/ -name dune -delete

.PHONY: all tests test runtest runtests doc clean installdoc

=== debian/changelog ===
js-of-ocaml (3.8.0-2) unstable; urgency=medium

  * Properly build libjs-of-ocaml-doc (Closes: #987458)

 -- Stéphane Glondu <glondu@debian.org>  Sun, 25 Apr 2021 17:44:21 +0200

js-of-ocaml (3.8.0-1) unstable; urgency=medium

  * New upstream release
  * Bump Standards-Version to 4.5.1
  * Add "Multi-Arch: foreign" to libjs-of-ocaml-doc

 -- Stéphane Glondu <glondu@debian.org>  Sat, 05 Dec 2020 14:39:31 +0100

js-of-ocaml (3.7.1-1) unstable; urgency=medium

  * New upstream release

 -- Stéphane Glondu <glondu@debian.org>  Sun, 08 Nov 2020 05:36:03 +0100

js-of-ocaml (3.7.0-3) unstable; urgency=medium

  * Add libgraphics-ocaml-dev to Build-Depends

 -- Stéphane Glondu <glondu@debian.org>  Wed, 14 Oct 2020 14:58:07 +0200

=== debian/control ===
--- 
+++ 
@@ -6,14 +6,14 @@
 Build-Depends:
  debhelper-compat (= 13),
  ocaml,
+ ocaml-odoc,
  ocaml-dune (>= 2.5),
  ocaml-findlib,
  ocamlbuild,
  libfindlib-ocaml-dev,
+ libgraphics-ocaml-dev,
  libcmdliner-ocaml-dev,
- libmigrate-parsetree-ocaml-dev (>= 1.4),
- libppx-tools-versioned-ocaml-dev (>= 5.2.3),
- libppxlib-ocaml-dev (>= 0.14.0),
+ libppxlib-ocaml-dev (>= 0.15.0),
  libyojson-ocaml-dev,
  libuchar-ocaml-dev,
  liblwt-ocaml-dev,
@@ -23,7 +23,7 @@
  menhir,
  libmenhir-ocaml-dev,
  dh-ocaml
-Standards-Version: 4.5.0
+Standards-Version: 4.5.1
 Rules-Requires-Root: no
 Homepage: http://ocsigen.org/js_of_ocaml
 Vcs-Browser: https://salsa.debian.org/ocaml-team/js-of-ocaml
@@ -107,7 +107,10 @@
 Package: libjs-of-ocaml-doc
 Section: doc
 Architecture: all
-Depends: ${misc:Depends}
+Multi-Arch: foreign
+Depends:
+ libjs-bootstrap,
+ ${misc:Depends}
 Description: OCaml bytecode to JavaScript compiler (documentation)
  Js_of_ocaml is a compiler of OCaml bytecode to JavaScript. It makes
  it possible to run OCaml programs in a web browser.

=== debian/rules ===
--- 
+++ 
@@ -39,6 +39,7 @@
 	$(DUNE_INSTALL) js_of_ocaml-toplevel
 	dune build -p js_of_ocaml-tyxml
 	$(DUNE_INSTALL) js_of_ocaml-tyxml
+	$(MAKE) doc
 
 override_dh_auto_test:
 # Needs ppx-expect
@@ -51,4 +52,13 @@
 	done
 	rm -f debian/tmp/usr/doc/js_of_ocaml/LICENSE
 
-override_dh_dwz:
+override_dh_install:
+	dh_install
+	mkdir -p debian/libjs-of-ocaml-doc/usr/share/doc/libjs-of-ocaml-doc
+	rm -rf debian/libjs-of-ocaml-doc/usr/share/doc/libjs-of-ocaml-doc/api
+	rm -rf debian/libjs-of-ocaml-doc/usr/share/doc/libjs-of-ocaml-doc/manual
+	cp -a _build/default/_doc/_html debian/libjs-of-ocaml-doc/usr/share/doc/libjs-of-ocaml-doc/api
+	cp -a _build/default/manual debian/libjs-of-ocaml-doc/usr/share/doc/libjs-of-ocaml-doc/manual
+	sed -i \
+	  's@href=".*//maxcdn\.bootstrapcdn\.com/bootstrap.*/bootstrap\.min\.css"@href="file:///usr/share/javascript/bootstrap/css/bootstrap.min.css"@g' \
+	  debian/libjs-of-ocaml-doc/usr/share/doc/libjs-of-ocaml-doc/manual/files/toplevel/index.html

=== debian/watch ===
version=3
https://github.com/ocsigen/js_of_ocaml/releases .*-([0-9.]+)\.tbz

## js-of-ocaml 3.11.0

=== Makefile ===
--- 
+++ 
@@ -1,5 +1,5 @@
 all:
-	dune build @install @default -j 8
+	dune build @all
 
 tests:
 	dune runtest

=== debian/changelog ===
js-of-ocaml (3.11.0-1build3) jammy; urgency=medium

  * No-change rebuild for ocaml abi changes.

 -- Matthias Klose <doko@ubuntu.com>  Fri, 25 Feb 2022 16:20:12 +0100

js-of-ocaml (3.11.0-1build2) jammy; urgency=medium

  * No-change rebuild for ocaml abi changes.

 -- Matthias Klose <doko@ubuntu.com>  Fri, 28 Jan 2022 15:48:22 +0100

js-of-ocaml (3.11.0-1build1) jammy; urgency=medium

  * No-change rebuild for ocaml abi changes.

 -- Matthias Klose <doko@ubuntu.com>  Wed, 26 Jan 2022 01:06:31 +0100

js-of-ocaml (3.11.0-1) unstable; urgency=medium

  * New upstream release
  * Do not build doc to bootstrap with OCaml 4.13.1
  * Bump Standards-Version to 4.6.0

 -- Stéphane Glondu <glondu@debian.org>  Fri, 21 Jan 2022 11:30:21 +0100

=== debian/control ===
--- 
+++ 
@@ -6,7 +6,6 @@
 Build-Depends:
  debhelper-compat (= 13),
  ocaml,
- ocaml-odoc,
  ocaml-dune (>= 2.5),
  ocaml-findlib,
  ocamlbuild,
@@ -23,9 +22,9 @@
  menhir,
  libmenhir-ocaml-dev,
  dh-ocaml
-Standards-Version: 4.5.1
+Standards-Version: 4.6.0
 Rules-Requires-Root: no
-Homepage: http://ocsigen.org/js_of_ocaml
+Homepage: https://ocsigen.org/js_of_ocaml
 Vcs-Browser: https://salsa.debian.org/ocaml-team/js-of-ocaml
 Vcs-Git: https://salsa.debian.org/ocaml-team/js-of-ocaml.git

=== debian/rules ===
--- 
+++ 
@@ -1,5 +1,7 @@
 #!/usr/bin/make -f
 # -*- makefile -*-
+
+DEB_BUILD_OPTIONS += nodoc
 
 DESTDIR=$(CURDIR)/debian/tmp
 
@@ -39,7 +41,9 @@
 	$(DUNE_INSTALL) js_of_ocaml-toplevel
 	dune build -p js_of_ocaml-tyxml
 	$(DUNE_INSTALL) js_of_ocaml-tyxml
+ifeq (,$(filter nodoc,$(DEB_BUILD_OPTIONS)))
 	$(MAKE) doc
+endif
 
 override_dh_auto_test:
 # Needs ppx-expect
@@ -57,8 +61,10 @@
 	mkdir -p debian/libjs-of-ocaml-doc/usr/share/doc/libjs-of-ocaml-doc
 	rm -rf debian/libjs-of-ocaml-doc/usr/share/doc/libjs-of-ocaml-doc/api
 	rm -rf debian/libjs-of-ocaml-doc/usr/share/doc/libjs-of-ocaml-doc/manual
+ifeq (,$(filter nodoc,$(DEB_BUILD_OPTIONS)))
 	cp -a _build/default/_doc/_html debian/libjs-of-ocaml-doc/usr/share/doc/libjs-of-ocaml-doc/api
 	cp -a _build/default/manual debian/libjs-of-ocaml-doc/usr/share/doc/libjs-of-ocaml-doc/manual
 	sed -i \
 	  's@href=".*//maxcdn\.bootstrapcdn\.com/bootstrap.*/bootstrap\.min\.css"@href="file:///usr/share/javascript/bootstrap/css/bootstrap.min.css"@g' \
 	  debian/libjs-of-ocaml-doc/usr/share/doc/libjs-of-ocaml-doc/manual/files/toplevel/index.html
+endif
